package uk.ac.ucl.cs.slangta.editor.actions;

import java.util.Collection;

import javax.jmi.reflect.RefClass;
import javax.jmi.reflect.RefObject;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

import uk.ac.ucl.cs.emofocl.jmi.reflect.RefClassImpl;
import uk.ac.ucl.cs.emofocl.plugin.xmieditor.tree.DAGNode;
import uk.ac.ucl.cs.emofocl.plugin.xmieditor.tree.JMITreeViewer;
import uk.ac.ucl.cs.slangta.jmi.impl.slang.SLA_Impl;
import uk.ac.ucl.cs.slangta.jmi.impl.slang.es.FixedLatencyFailureModeDefinition_ClassImpl;
import uk.ac.ucl.cs.slangta.jmi.impl.slang.es.FixedLatencyFailureModeDefinition_Impl;
import uk.ac.ucl.cs.slangta.jmi.services.Party;
import uk.ac.ucl.cs.slangta.jmi.slang.AuxiliaryClause;
import uk.ac.ucl.cs.slangta.jmi.slang.es.FixedLatencyFailureModeDefinition;
import uk.ac.ucl.cs.slangta.jmi.slang.es.FixedLatencyFailureModeDefinitionClass;
import uk.ac.ucl.cs.slangta.jmi.slang.es.InputThroughputScheduledSlidingPenaltyClause;
import uk.ac.ucl.cs.slangta.jmi.slang.es.ReliabilityFixedWindowFixedFailuresScheduledSlidingPenaltyClause;

import uk.ac.ucl.cs.slangta.jmi.types.Duration;
import uk.ac.ucl.cs.slangta.puppet.AgreementGenerator;



public class PuppetAction 
		extends Action 
		implements ISelectionChangedListener {

	
	private final JMITreeViewer PARENT;
	private GeneratePuppetWizard wiz;
	
	
	public PuppetAction(JMITreeViewer parent) {
		PARENT = parent;
		PARENT.addSelectionChangedListener(this);
		selectionChanged(null);
	}
	
	public String getText() {

		return "Generate Puppets";
	}
	
	public String getToolTipText() {
		
		return "Generate Puppet testbeds"; 
	}
	
	public void run() {
		
		IStructuredSelection selection =
			(IStructuredSelection)PARENT.getSelection();

		DAGNode node = (DAGNode)selection.getFirstElement();
		
		SLA_Impl sla = (SLA_Impl)node.object;
		
		
		Shell parentShell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
	
		
		wiz = new GeneratePuppetWizard();
		wiz.init(sla);
		

		WizardDialog dialog = new WizardDialog(parentShell,wiz);
		int n = dialog.open();

	}	
	
	public void selectionChanged(SelectionChangedEvent event) {

		IStructuredSelection selection =
			(IStructuredSelection)PARENT.getSelection();
		if(selection.isEmpty()) this.setEnabled(false);
		else {
				
			Object node = ((DAGNode)selection.getFirstElement()).object;
			if ( node.getClass().getName() == "uk.ac.ucl.cs.slangta.jmi.impl.slang.SLA_Impl" ) {
				this.setEnabled(true);
			}
			else this.setEnabled(false);
		}
	}
	
}

