package uk.ac.ucl.cs.slangta.puppet;

import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument;
import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument.PuppetSLO;

import java.math.BigDecimal;
import java.math.BigInteger;

import org.apache.xmlbeans.XmlObject;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.GuaranteeTermType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.ServiceRoleType;
import org.ggf.schemas.graap.x2005.x09.wsAgreement.TermCompositorType;
import org.w3c.dom.Node;

import uk.ac.ucl.cs.slangta.jmi.impl.slang.SLA_Impl;

public class ReliabilityGuaranteeTermsGenerator extends GuaranteeTermGenerator {

	private BigDecimal maxfailures;
	private BigInteger relwindow;
	
    public ReliabilityGuaranteeTermsGenerator(SLA_Impl slangSpecification){
        super(slangSpecification);
    }
    
    public ReliabilityGuaranteeTermsGenerator (SLA_Impl slangSpecification, int mfail, double relw, TermCompositorType compositorElement){
        super(slangSpecification,compositorElement);
        maxfailures = new BigDecimal(new Integer(mfail).toString());
        String mystr = (new Double(relw)).toString().split("\\.")[0];
        relwindow = new BigInteger(mystr);
    
    }

    
    
    /*
     * Appends GuaranteeTerms expessing Reliability constraints to the
     * TermCompositorType and returns it
     */
    //@Override
    public TermCompositorType generate() {
        GuaranteeTermType reliabilityGT = compositorElement.addNewGuaranteeTerm();

        reliabilityGT.setObligated(ServiceRoleType.SERVICE_PROVIDER);
        reliabilityGT.setName("ReliabilityGT_" + guaranteeTermId);
        guaranteeTermId++;

        generateServiceScope(reliabilityGT);
        generateBusinessValueList(reliabilityGT);
        generateQualifyingCondition(reliabilityGT);

        Node importedNode;
        XmlObject sloElement = reliabilityGT.addNewServiceLevelObjective();

        PuppetSLODocument pSLODoc = PuppetSLODocument.Factory.newInstance();
        pSLODoc.addNewPuppetSLO();
        PuppetSLO pSLO = pSLODoc.getPuppetSLO();
        pSLO.addNewReliability();

        // -- A COMMENT TO FRANCO --
        // HERE THE VALUES HOLD BY slangSpecification
        pSLO.getReliability().setReliabilitywindow(relwindow);
        
        // FRANCO: We need to agree on how to compute this thing!
	//        pSLO.getReliability().setReliabilityPerc(BigDecimal.valueOf(99));
	// Modified by Gulyx
        pSLO.getReliability().setReliabilityPerc(maxfailures);

        // -- A COMMENT TO FRANCO --
        // FOR THE MOMENT IGNORE THIS PART
        pSLO.getReliability().addNewDistribution();
        pSLO.getReliability().getDistribution().setGaussian("10");
        
        // System.out.println(pSLODoc.xmlText());

        importedNode = sloElement.getDomNode().getOwnerDocument().importNode(pSLO.getDomNode(), true);
        sloElement.getDomNode().appendChild(importedNode);

        return compositorElement;
    }
    
    
}
