package uk.ac.ucl.cs.slangta.tautils;
import java.io.*;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

import java.util.*;

public class Transition 
{ 
    /* A class to store a transition between states of an automaton */
    
    private String source; // The source state
    private String target; // The destination state
    private Vector labels; // The label(s) for the transition, a
    // vector of strings
    private Vector cresets; // The clock(s) to be reset during
    // transition, a vector of strings
    private String guard; // For the moment a string, but it should be
    // a parse tree for the guard.


    public Transition() {
	labels = new Vector();
	cresets = new Vector();
    }

    public Transition(String s, String t, Vector labs, Vector cr, String gu
		      ) 
    {
	source = s;
	target = t;
	labels = labs;
	cresets = cr;
	guard = gu;
    }

    public void setSource(String s) {
	source = s;
    }

    public void setTarget(String t) {
	target = t;
    }

    public void setGuard(String g) {
	guard = g;
    }

    public void setLabels(Vector labs) {
	labels = labs;
    }

    public void setClockResets(Vector cr) {
	cresets = cr;
    }

    public void addLabel(String lab) {
	labels.addElement(lab);
    }
    
    public void addReset(String res) {
	cresets.addElement(res);
    }

    public String getSource() {
    	return source;
    }
    
    public String getTarget() {
    	return target;
    }
    
    public Vector getLabels() {
    	return labels;
    }
    
    public Vector getCResets() {
    	return cresets;
    }
    
    public String getGuard() {
    	return guard;
    }
    
    public void printTransition() {
	System.out.println("Source: "+source);
	System.out.println("Target: "+target);
	System.out.println("Labels: "+labels);
	System.out.println("Resets: "+cresets);
	System.out.println("Guard: "+guard);
    }

}
